﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;

namespace JustAddCode.PackageAnything.FeatureEater
{
    public class FeatureEaterFeatureReceiver : SPFeatureReceiver
    {
        public override void FeatureActivated(SPFeatureReceiverProperties properties)
        {
            //throw new System.NotImplementedException();
        }

        public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
        {
            SPWeb web = properties.Feature.Parent as SPWeb;
            if (web == null)
                return;

            SPFarm farm = SPFarm.Local;



            var actives = from SPFeatureDefinition f in farm.FeatureDefinitions
                      where f.ActivationDependencies.Count > 0
                      select f;

            foreach (SPFeatureDefinition active in actives)
            {
                foreach (SPFeatureDependency dep in active.ActivationDependencies)
                {
                    if (dep.FeatureId == properties.Feature.DefinitionId)
                    {
                        Debug.WriteLine("Eating " + active.Id);
                        foreach (SPElementDefinition ed in active.GetElementDefinitions(System.Globalization.CultureInfo.InvariantCulture))
                        {
                            if(ed.ElementType == "ListInstance")
                            {
                                // WEATHER!
                                try
                                {
                                    SPList list = web.Lists[ed.XmlDefinition.Attributes["Title"].Value];
                                    list.Delete();
                                }
                                catch (Exception e)
                                {
                                    System.Diagnostics.Debug.WriteLine("Failed to eat: " + active.Id);
                                }
                            }
                            if(ed.ElementType == "Module")
                            {
                                foreach (XmlNode o in ed.XmlDefinition.ChildNodes)
                                {
                                    try
                                    {
                                        SPFile file = web.RootFolder.Files[o.Attributes["Url"].Value];
                                        file.Delete();
                                    }
                                    catch (Exception e)
                                    {
                                        System.Diagnostics.Debug.WriteLine("Failed to eat: " + active.Id);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        public override void FeatureInstalled(SPFeatureReceiverProperties properties)
        {}

        public override void FeatureUninstalling(SPFeatureReceiverProperties properties)
        {}
    }
}
