﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using Microsoft.SharePoint.Administration;

namespace JustAddCode.PackageAnything.WebConfig
{
    public class ConfigModification
    {
        public XAttribute Name;
        public XAttribute Path;
        public XAttribute Owner;
        public XAttribute Sequence;
        public string ConfigValue;

        SPWebConfigModification.SPWebConfigModificationType _configType =
                SPWebConfigModification.SPWebConfigModificationType.EnsureChildNode;
        public SPWebConfigModification.SPWebConfigModificationType ConfigType
        {
            get { return _configType; }
        }

        public void SetConfigType(string configType)
        {
            SPWebConfigModification.SPWebConfigModificationType wcType =
                SPWebConfigModification.SPWebConfigModificationType.EnsureChildNode;
            switch(configType.ToUpper())
            {
                case "ENSUREATTRIBUTE":
                    wcType = SPWebConfigModification.SPWebConfigModificationType.EnsureAttribute;
                    break;
                case "ENSURECHILDNODE":
                    wcType = SPWebConfigModification.SPWebConfigModificationType.EnsureChildNode;
                    break;
                case "ENSURESECTION":
                    wcType = SPWebConfigModification.SPWebConfigModificationType.EnsureSection;
                    break;
                default:
                    throw new ArgumentException("Unable to find corresponding SPWebConfigModifcationType for object");
            }
            _configType = wcType;
        }

        public SPWebConfigModification ToSPWebConfigModification()
        {
            SPWebConfigModification config = new SPWebConfigModification();
            config.Name = Name.Value;
            config.Owner = Owner.Value;
            config.Path = Path.Value;
            config.Sequence = Convert.ToUInt32(Sequence.Value);
            config.Type = ConfigType;
            config.Value = ConfigValue;

            return config;
        }

    }
}
